# DNS # DNSSEC ## DNSSEC Details `client.dns.dnssec.get(DNSSECGetParamsparams, RequestOptionsoptions?): DNSSEC` **get** `/zones/{zone_id}/dnssec` Details about DNSSEC status and configuration. ### Parameters - `params: DNSSECGetParams` - `zone_id: string` Identifier. ### Returns - `DNSSEC` - `algorithm?: string | null` Algorithm key code. - `digest?: string | null` Digest hash. - `digest_algorithm?: string | null` Type of digest algorithm. - `digest_type?: string | null` Coded type for digest algorithm. - `dnssec_multi_signer?: boolean` If true, multi-signer DNSSEC is enabled on the zone, allowing multiple providers to serve a DNSSEC-signed zone at the same time. This is required for DNSKEY records (except those automatically generated by Cloudflare) to be added to the zone. See [Multi-signer DNSSEC](https://developers.cloudflare.com/dns/dnssec/multi-signer-dnssec/) for details. - `dnssec_presigned?: boolean` If true, allows Cloudflare to transfer in a DNSSEC-signed zone including signatures from an external provider, without requiring Cloudflare to sign any records on the fly. Note that this feature has some limitations. See [Cloudflare as Secondary](https://developers.cloudflare.com/dns/zone-setups/zone-transfers/cloudflare-as-secondary/setup/#dnssec) for details. - `dnssec_use_nsec3?: boolean` If true, enables the use of NSEC3 together with DNSSEC on the zone. Combined with setting dnssec_presigned to true, this enables the use of NSEC3 records when transferring in from an external provider. If dnssec_presigned is instead set to false (default), NSEC3 records will be generated and signed at request time. See [DNSSEC with NSEC3](https://developers.cloudflare.com/dns/dnssec/enable-nsec3/) for details. - `ds?: string | null` Full DS record. - `flags?: number | null` Flag for DNSSEC record. - `key_tag?: number | null` Code for key tag. - `key_type?: string | null` Algorithm key type. - `modified_on?: string | null` When DNSSEC was last modified. - `public_key?: string | null` Public key for DS record. - `status?: "active" | "pending" | "disabled" | 2 more` Status of DNSSEC, based on user-desired state and presence of necessary records. - `"active"` - `"pending"` - `"disabled"` - `"pending-disabled"` - `"error"` ### Example ```typescript import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const dnssec = await client.dns.dnssec.get({ zone_id: '023e105f4ecef8ad9ca31a8372d0c353' }); console.log(dnssec.algorithm); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "algorithm": "13", "digest": "48E939042E82C22542CB377B580DFDC52A361CEFDC72E7F9107E2B6BD9306A45", "digest_algorithm": "SHA256", "digest_type": "2", "dnssec_multi_signer": false, "dnssec_presigned": true, "dnssec_use_nsec3": false, "ds": "example.com. 3600 IN DS 16953 13 2 48E939042E82C22542CB377B580DFDC52A361CEFDC72E7F9107E2B6BD9306A45", "flags": 257, "key_tag": 42, "key_type": "ECDSAP256SHA256", "modified_on": "2014-01-01T05:20:00Z", "public_key": "oXiGYrSTO+LSCJ3mohc8EP+CzF9KxBj8/ydXJ22pKuZP3VAC3/Md/k7xZfz470CoRyZJ6gV6vml07IC3d8xqhA==", "status": "active" } } ``` ## Edit DNSSEC Status `client.dns.dnssec.edit(DNSSECEditParamsparams, RequestOptionsoptions?): DNSSEC` **patch** `/zones/{zone_id}/dnssec` Enable or disable DNSSEC. ### Parameters - `params: DNSSECEditParams` - `zone_id: string` Path param: Identifier. - `dnssec_multi_signer?: boolean` Body param: If true, multi-signer DNSSEC is enabled on the zone, allowing multiple providers to serve a DNSSEC-signed zone at the same time. This is required for DNSKEY records (except those automatically generated by Cloudflare) to be added to the zone. See [Multi-signer DNSSEC](https://developers.cloudflare.com/dns/dnssec/multi-signer-dnssec/) for details. - `dnssec_presigned?: boolean` Body param: If true, allows Cloudflare to transfer in a DNSSEC-signed zone including signatures from an external provider, without requiring Cloudflare to sign any records on the fly. Note that this feature has some limitations. See [Cloudflare as Secondary](https://developers.cloudflare.com/dns/zone-setups/zone-transfers/cloudflare-as-secondary/setup/#dnssec) for details. - `dnssec_use_nsec3?: boolean` Body param: If true, enables the use of NSEC3 together with DNSSEC on the zone. Combined with setting dnssec_presigned to true, this enables the use of NSEC3 records when transferring in from an external provider. If dnssec_presigned is instead set to false (default), NSEC3 records will be generated and signed at request time. See [DNSSEC with NSEC3](https://developers.cloudflare.com/dns/dnssec/enable-nsec3/) for details. - `status?: "active" | "disabled"` Body param: Status of DNSSEC, based on user-desired state and presence of necessary records. - `"active"` - `"disabled"` ### Returns - `DNSSEC` - `algorithm?: string | null` Algorithm key code. - `digest?: string | null` Digest hash. - `digest_algorithm?: string | null` Type of digest algorithm. - `digest_type?: string | null` Coded type for digest algorithm. - `dnssec_multi_signer?: boolean` If true, multi-signer DNSSEC is enabled on the zone, allowing multiple providers to serve a DNSSEC-signed zone at the same time. This is required for DNSKEY records (except those automatically generated by Cloudflare) to be added to the zone. See [Multi-signer DNSSEC](https://developers.cloudflare.com/dns/dnssec/multi-signer-dnssec/) for details. - `dnssec_presigned?: boolean` If true, allows Cloudflare to transfer in a DNSSEC-signed zone including signatures from an external provider, without requiring Cloudflare to sign any records on the fly. Note that this feature has some limitations. See [Cloudflare as Secondary](https://developers.cloudflare.com/dns/zone-setups/zone-transfers/cloudflare-as-secondary/setup/#dnssec) for details. - `dnssec_use_nsec3?: boolean` If true, enables the use of NSEC3 together with DNSSEC on the zone. Combined with setting dnssec_presigned to true, this enables the use of NSEC3 records when transferring in from an external provider. If dnssec_presigned is instead set to false (default), NSEC3 records will be generated and signed at request time. See [DNSSEC with NSEC3](https://developers.cloudflare.com/dns/dnssec/enable-nsec3/) for details. - `ds?: string | null` Full DS record. - `flags?: number | null` Flag for DNSSEC record. - `key_tag?: number | null` Code for key tag. - `key_type?: string | null` Algorithm key type. - `modified_on?: string | null` When DNSSEC was last modified. - `public_key?: string | null` Public key for DS record. - `status?: "active" | "pending" | "disabled" | 2 more` Status of DNSSEC, based on user-desired state and presence of necessary records. - `"active"` - `"pending"` - `"disabled"` - `"pending-disabled"` - `"error"` ### Example ```typescript import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const dnssec = await client.dns.dnssec.edit({ zone_id: '023e105f4ecef8ad9ca31a8372d0c353' }); console.log(dnssec.algorithm); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "algorithm": "13", "digest": "48E939042E82C22542CB377B580DFDC52A361CEFDC72E7F9107E2B6BD9306A45", "digest_algorithm": "SHA256", "digest_type": "2", "dnssec_multi_signer": false, "dnssec_presigned": true, "dnssec_use_nsec3": false, "ds": "example.com. 3600 IN DS 16953 13 2 48E939042E82C22542CB377B580DFDC52A361CEFDC72E7F9107E2B6BD9306A45", "flags": 257, "key_tag": 42, "key_type": "ECDSAP256SHA256", "modified_on": "2014-01-01T05:20:00Z", "public_key": "oXiGYrSTO+LSCJ3mohc8EP+CzF9KxBj8/ydXJ22pKuZP3VAC3/Md/k7xZfz470CoRyZJ6gV6vml07IC3d8xqhA==", "status": "active" } } ``` ## Delete DNSSEC records `client.dns.dnssec.delete(DNSSECDeleteParamsparams, RequestOptionsoptions?): DNSSECDeleteResponse` **delete** `/zones/{zone_id}/dnssec` Delete DNSSEC. ### Parameters - `params: DNSSECDeleteParams` - `zone_id: string` Identifier. ### Returns - `DNSSECDeleteResponse = string` ### Example ```typescript import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const dnssec = await client.dns.dnssec.delete({ zone_id: '023e105f4ecef8ad9ca31a8372d0c353' }); console.log(dnssec); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": "" } ``` ## Domain Types ### DNSSEC - `DNSSEC` - `algorithm?: string | null` Algorithm key code. - `digest?: string | null` Digest hash. - `digest_algorithm?: string | null` Type of digest algorithm. - `digest_type?: string | null` Coded type for digest algorithm. - `dnssec_multi_signer?: boolean` If true, multi-signer DNSSEC is enabled on the zone, allowing multiple providers to serve a DNSSEC-signed zone at the same time. This is required for DNSKEY records (except those automatically generated by Cloudflare) to be added to the zone. See [Multi-signer DNSSEC](https://developers.cloudflare.com/dns/dnssec/multi-signer-dnssec/) for details. - `dnssec_presigned?: boolean` If true, allows Cloudflare to transfer in a DNSSEC-signed zone including signatures from an external provider, without requiring Cloudflare to sign any records on the fly. Note that this feature has some limitations. See [Cloudflare as Secondary](https://developers.cloudflare.com/dns/zone-setups/zone-transfers/cloudflare-as-secondary/setup/#dnssec) for details. - `dnssec_use_nsec3?: boolean` If true, enables the use of NSEC3 together with DNSSEC on the zone. Combined with setting dnssec_presigned to true, this enables the use of NSEC3 records when transferring in from an external provider. If dnssec_presigned is instead set to false (default), NSEC3 records will be generated and signed at request time. See [DNSSEC with NSEC3](https://developers.cloudflare.com/dns/dnssec/enable-nsec3/) for details. - `ds?: string | null` Full DS record. - `flags?: number | null` Flag for DNSSEC record. - `key_tag?: number | null` Code for key tag. - `key_type?: string | null` Algorithm key type. - `modified_on?: string | null` When DNSSEC was last modified. - `public_key?: string | null` Public key for DS record. - `status?: "active" | "pending" | "disabled" | 2 more` Status of DNSSEC, based on user-desired state and presence of necessary records. - `"active"` - `"pending"` - `"disabled"` - `"pending-disabled"` - `"error"` ### DNSSEC Delete Response - `DNSSECDeleteResponse = string` # Records ## List DNS Records `client.dns.records.list(RecordListParamsparams, RequestOptionsoptions?): V4PagePaginationArray` **get** `/zones/{zone_id}/dns_records` List, search, sort, and filter a zones' DNS records. ### Parameters - `params: RecordListParams` - `zone_id: string` Path param: Identifier. - `comment?: Comment` Query param - `absent?: string` If this parameter is present, only records *without* a comment are returned. - `contains?: string` Substring of the DNS record comment. Comment filters are case-insensitive. - `endswith?: string` Suffix of the DNS record comment. Comment filters are case-insensitive. - `exact?: string` Exact value of the DNS record comment. Comment filters are case-insensitive. - `present?: string` If this parameter is present, only records *with* a comment are returned. - `startswith?: string` Prefix of the DNS record comment. Comment filters are case-insensitive. - `content?: Content` Query param - `contains?: string` Substring of the DNS record content. Content filters are case-insensitive. - `endswith?: string` Suffix of the DNS record content. Content filters are case-insensitive. - `exact?: string` Exact value of the DNS record content. Content filters are case-insensitive. - `startswith?: string` Prefix of the DNS record content. Content filters are case-insensitive. - `direction?: SortDirection` Query param: Direction to order DNS records in. - `"asc"` - `"desc"` - `include_shadow_metadata?: boolean` Query param: Whether to include shadow metadata in the `meta` field of each record in the response. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `match?: "any" | "all"` Query param: Whether to match all search requirements or at least one (any). If set to `all`, acts like a logical AND between filters. If set to `any`, acts like a logical OR instead. Note that the interaction between tag filters is controlled by the `tag-match` parameter instead. - `"any"` - `"all"` - `name?: Name` Query param - `contains?: string` Substring of the DNS record name. Name filters are case-insensitive. - `endswith?: string` Suffix of the DNS record name. Name filters are case-insensitive. - `exact?: string` Exact value of the DNS record name. Name filters are case-insensitive. - `startswith?: string` Prefix of the DNS record name. Name filters are case-insensitive. - `order?: "type" | "name" | "content" | 2 more` Query param: Field to order DNS records by. - `"type"` - `"name"` - `"content"` - `"ttl"` - `"proxied"` - `page?: number` Query param: Page number of paginated results. - `per_page?: number` Query param: Number of DNS records per page. - `proxied?: boolean` Query param: Whether the record is receiving the performance and security benefits of Cloudflare. - `search?: string` Query param: Allows searching in multiple properties of a DNS record simultaneously. This parameter is intended for human users, not automation. Its exact behavior is intentionally left unspecified and is subject to change in the future. This parameter works independently of the `match` setting. For automated searches, please use the other available parameters. - `shadowed_by_name?: string` Query param: Filters to records at or below the given NS delegation name, excluding the NS records that form the delegation itself. The value must be a subdomain of the zone; the zone apex is not accepted. Requires `include_shadow_metadata=true`. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowing_name?: string` Query param: Returns NS records that shadow the given name, searching at the name itself and each of its ancestor names within the zone, excluding the zone apex. The value must be a subdomain of the zone; the zone apex is not accepted. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `tag?: Tag` Query param - `absent?: string` Name of a tag which must *not* be present on the DNS record. Tag filters are case-insensitive. - `contains?: string` A tag and value, of the form `:`. The API will only return DNS records that have a tag named `` whose value contains ``. Tag filters are case-insensitive. - `endswith?: string` A tag and value, of the form `:`. The API will only return DNS records that have a tag named `` whose value ends with ``. Tag filters are case-insensitive. - `exact?: string` A tag and value, of the form `:`. The API will only return DNS records that have a tag named `` whose value is ``. Tag filters are case-insensitive. - `present?: string` Name of a tag which must be present on the DNS record. Tag filters are case-insensitive. - `startswith?: string` A tag and value, of the form `:`. The API will only return DNS records that have a tag named `` whose value starts with ``. Tag filters are case-insensitive. - `tag_match?: "any" | "all"` Query param: Whether to match all tag search requirements or at least one (any). If set to `all`, acts like a logical AND between tag filters. If set to `any`, acts like a logical OR instead. Note that the regular `match` parameter is still used to combine the resulting condition with other filters that aren't related to tags. - `"any"` - `"all"` - `type?: "A" | "AAAA" | "CAA" | 18 more` Query param: Record type. - `"A"` - `"AAAA"` - `"CAA"` - `"CERT"` - `"CNAME"` - `"DNSKEY"` - `"DS"` - `"HTTPS"` - `"LOC"` - `"MX"` - `"NAPTR"` - `"NS"` - `"OPENPGPKEY"` - `"PTR"` - `"SMIMEA"` - `"SRV"` - `"SSHFP"` - `"SVCB"` - `"TLSA"` - `"TXT"` - `"URI"` ### Returns - `RecordResponse = ARecord | AAAARecord | CNAMERecord | 18 more` - `ARecord extends ARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `AAAARecord extends AAAARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CNAMERecord extends CNAMERecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `MXRecord extends MXRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `NSRecord extends NSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `OpenpgpkeyRecord` - `id: string` Identifier. - `comment: string` Comments or notes about the DNS record. This field has no effect on DNS responses. - `content: string` A single Base64-encoded OpenPGP Transferable Public Key (RFC 4880 Section 11.1) - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `name: string` Complete DNS record name, including the zone name, in Punycode. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `proxied: boolean` Whether the record is receiving the performance and security benefits of Cloudflare. - `settings: Settings` Settings for the DNS record. - `ipv4_only?: boolean` When enabled, only A records will be generated, and AAAA records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `ipv6_only?: boolean` When enabled, only AAAA records will be generated, and A records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `tags: Array` Custom tags for the DNS record. This field has no effect on DNS responses. - `ttl: TTL` Time To Live (TTL) of the DNS record in seconds. Setting to 1 means 'automatic'. Value must be between 60 and 86400, with the minimum reduced to 30 for Enterprise zones. - `number` - `1` - `1` - `type: "OPENPGPKEY"` Record type. - `"OPENPGPKEY"` - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `PTRRecord extends PTRRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `TXTRecord extends TXTRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CAARecord extends CAARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CERTRecord extends CERTRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `DNSKEYRecord extends DNSKEYRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `DSRecord extends DSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `HTTPSRecord extends HTTPSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `LOCRecord extends LOCRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `NAPTRRecord extends NAPTRRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SMIMEARecord extends SMIMEARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SRVRecord extends SRVRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SSHFPRecord extends SSHFPRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SVCBRecord extends SVCBRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `TLSARecord extends TLSARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `URIRecord extends URIRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. ### Example ```typescript import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); // Automatically fetches more pages as needed. for await (const recordResponse of client.dns.records.list({ zone_id: '023e105f4ecef8ad9ca31a8372d0c353', })) { console.log(recordResponse); } ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": [ { "name": "example.com", "ttl": 3600, "type": "A", "comment": "Domain verification record", "content": "198.51.100.4", "private_routing": true, "proxied": true, "settings": { "ipv4_only": true, "ipv6_only": true }, "tags": [ "owner:dns-team" ], "id": "023e105f4ecef8ad9ca31a8372d0c353", "created_on": "2014-01-01T05:20:00.12345Z", "meta": { "dead_glue": true, "is_glue": true, "shadowed_by": [ "372e67954025e0ba6aaa6d586b9e0b59" ], "shadowed_records_count": 42 }, "modified_on": "2014-01-01T05:20:00.12345Z", "proxiable": true, "comment_modified_on": "2024-01-01T05:20:00.12345Z", "tags_modified_on": "2025-01-01T05:20:00.12345Z" } ], "result_info": { "count": 1, "page": 1, "per_page": 20, "total_count": 2000, "total_pages": 100 } } ``` ## DNS Record Details `client.dns.records.get(stringdnsRecordID, RecordGetParamsparams, RequestOptionsoptions?): RecordResponse` **get** `/zones/{zone_id}/dns_records/{dns_record_id}` Retrieves details for a specific DNS record in the zone. ### Parameters - `dnsRecordID: string` Identifier. - `params: RecordGetParams` - `zone_id: string` Path param: Identifier. - `include_shadow_metadata?: boolean` Query param: Whether to include shadow metadata in the `meta` field of each record in the response. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). ### Returns - `RecordResponse = ARecord | AAAARecord | CNAMERecord | 18 more` - `ARecord extends ARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `AAAARecord extends AAAARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CNAMERecord extends CNAMERecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `MXRecord extends MXRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `NSRecord extends NSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `OpenpgpkeyRecord` - `id: string` Identifier. - `comment: string` Comments or notes about the DNS record. This field has no effect on DNS responses. - `content: string` A single Base64-encoded OpenPGP Transferable Public Key (RFC 4880 Section 11.1) - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `name: string` Complete DNS record name, including the zone name, in Punycode. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `proxied: boolean` Whether the record is receiving the performance and security benefits of Cloudflare. - `settings: Settings` Settings for the DNS record. - `ipv4_only?: boolean` When enabled, only A records will be generated, and AAAA records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `ipv6_only?: boolean` When enabled, only AAAA records will be generated, and A records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `tags: Array` Custom tags for the DNS record. This field has no effect on DNS responses. - `ttl: TTL` Time To Live (TTL) of the DNS record in seconds. Setting to 1 means 'automatic'. Value must be between 60 and 86400, with the minimum reduced to 30 for Enterprise zones. - `number` - `1` - `1` - `type: "OPENPGPKEY"` Record type. - `"OPENPGPKEY"` - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `PTRRecord extends PTRRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `TXTRecord extends TXTRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CAARecord extends CAARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CERTRecord extends CERTRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `DNSKEYRecord extends DNSKEYRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `DSRecord extends DSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `HTTPSRecord extends HTTPSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `LOCRecord extends LOCRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `NAPTRRecord extends NAPTRRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SMIMEARecord extends SMIMEARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SRVRecord extends SRVRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SSHFPRecord extends SSHFPRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `SVCBRecord extends SVCBRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `TLSARecord extends TLSARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `URIRecord extends URIRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. ### Example ```typescript import Cloudflare from 'cloudflare'; const client = new Cloudflare({ apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted }); const recordResponse = await client.dns.records.get('023e105f4ecef8ad9ca31a8372d0c353', { zone_id: '023e105f4ecef8ad9ca31a8372d0c353', }); console.log(recordResponse); ``` #### Response ```json { "errors": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "messages": [ { "code": 1000, "message": "message", "documentation_url": "documentation_url", "source": { "pointer": "pointer" } } ], "success": true, "result": { "name": "example.com", "ttl": 3600, "type": "A", "comment": "Domain verification record", "content": "198.51.100.4", "private_routing": true, "proxied": true, "settings": { "ipv4_only": true, "ipv6_only": true }, "tags": [ "owner:dns-team" ], "id": "023e105f4ecef8ad9ca31a8372d0c353", "created_on": "2014-01-01T05:20:00.12345Z", "meta": { "dead_glue": true, "is_glue": true, "shadowed_by": [ "372e67954025e0ba6aaa6d586b9e0b59" ], "shadowed_records_count": 42 }, "modified_on": "2014-01-01T05:20:00.12345Z", "proxiable": true, "comment_modified_on": "2024-01-01T05:20:00.12345Z", "tags_modified_on": "2025-01-01T05:20:00.12345Z" } } ``` ## Create DNS Record `client.dns.records.create(RecordCreateParamsparams, RequestOptionsoptions?): RecordResponse` **post** `/zones/{zone_id}/dns_records` Create a new DNS record for a zone. Notes: - A/AAAA records cannot exist on the same name as CNAME records. - NS records cannot exist on the same name as any other record type. - Domain names are always represented in Punycode, even if Unicode characters were used when creating the record. ### Parameters - `RecordCreateParams = ARecord | AAAARecord | CNAMERecord | 18 more` - `RecordCreateParamsBase` - `zone_id: string` Path param: Identifier. - `name: string` Body param: Complete DNS record name, including the zone name, in Punycode. - `ttl: TTL` Body param: Time To Live (TTL) of the DNS record in seconds. Setting to 1 means 'automatic'. Value must be between 60 and 86400, with the minimum reduced to 30 for Enterprise zones. - `number` - `1` - `1` - `type: "A"` Body param: Record type. - `"A"` - `include_shadow_metadata?: boolean` Query param: Whether to include shadow metadata in the `meta` field of each record in the response. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `comment?: string` Body param: Comments or notes about the DNS record. This field has no effect on DNS responses. - `content?: string` Body param: A valid IPv4 address. - `private_routing?: boolean` Body param: Enables private network routing to the origin. - `proxied?: boolean` Body param: Whether the record is receiving the performance and security benefits of Cloudflare. - `settings?: Settings` Body param: Settings for the DNS record. - `ipv4_only?: boolean` When enabled, only A records will be generated, and AAAA records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `ipv6_only?: boolean` When enabled, only AAAA records will be generated, and A records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `tags?: Array` Body param: Custom tags for the DNS record. This field has no effect on DNS responses. - `ARecord extends RecordCreateParamsBase` - `AAAARecord extends RecordCreateParamsBase` - `CNAMERecord extends RecordCreateParamsBase` - `MXRecord extends RecordCreateParamsBase` - `NSRecord extends RecordCreateParamsBase` - `DNSRecordsOpenpgpkeyRecord extends RecordCreateParamsBase` - `PTRRecord extends RecordCreateParamsBase` - `TXTRecord extends RecordCreateParamsBase` - `CAARecord extends RecordCreateParamsBase` - `CERTRecord extends RecordCreateParamsBase` - `DNSKEYRecord extends RecordCreateParamsBase` - `DSRecord extends RecordCreateParamsBase` - `HTTPSRecord extends RecordCreateParamsBase` - `LOCRecord extends RecordCreateParamsBase` - `NAPTRRecord extends RecordCreateParamsBase` - `SMIMEARecord extends RecordCreateParamsBase` - `SRVRecord extends RecordCreateParamsBase` - `SSHFPRecord extends RecordCreateParamsBase` - `SVCBRecord extends RecordCreateParamsBase` - `TLSARecord extends RecordCreateParamsBase` - `URIRecord extends RecordCreateParamsBase` ### Returns - `RecordResponse = ARecord | AAAARecord | CNAMERecord | 18 more` - `ARecord extends ARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `AAAARecord extends AAAARecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `CNAMERecord extends CNAMERecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `MXRecord extends MXRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `NSRecord extends NSRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `OpenpgpkeyRecord` - `id: string` Identifier. - `comment: string` Comments or notes about the DNS record. This field has no effect on DNS responses. - `content: string` A single Base64-encoded OpenPGP Transferable Public Key (RFC 4880 Section 11.1) - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `name: string` Complete DNS record name, including the zone name, in Punycode. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `proxied: boolean` Whether the record is receiving the performance and security benefits of Cloudflare. - `settings: Settings` Settings for the DNS record. - `ipv4_only?: boolean` When enabled, only A records will be generated, and AAAA records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `ipv6_only?: boolean` When enabled, only AAAA records will be generated, and A records will not be created. This setting is intended for exceptional cases. Note that this option only applies to proxied records and it has no effect on whether Cloudflare communicates with the origin using IPv4 or IPv6. - `tags: Array` Custom tags for the DNS record. This field has no effect on DNS responses. - `ttl: TTL` Time To Live (TTL) of the DNS record in seconds. Setting to 1 means 'automatic'. Value must be between 60 and 86400, with the minimum reduced to 30 for Enterprise zones. - `number` - `1` - `1` - `type: "OPENPGPKEY"` Record type. - `"OPENPGPKEY"` - `comment_modified_on?: string` When the record comment was last modified. Omitted if there is no comment. - `tags_modified_on?: string` When the record tags were last modified. Omitted if there are no tags. - `PTRRecord extends PTRRecord` - `id: string` Identifier. - `created_on: string` When the record was created. - `meta: Meta` Extra Cloudflare-specific metadata about the record. - `dead_glue?: boolean` Whether this glue record is not served because a shallower NS delegation takes precedence over the deeper delegation that needs it. Present only when true; reachable glue carries only `is_glue`. See [Unreachable glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#unreachable-glue-records). - `is_glue?: boolean` Whether this A or AAAA record is glue for a subdomain NS delegation. See [Glue records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records#glue-records). - `shadowed_by?: Array` IDs of the NS records that shadow this record. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `shadowed_records_count?: number` Number of records shadowed by this NS delegation. See [Shadowed records](https://developers.cloudflare.com/dns/manage-dns-records/reference/shadowed-records). - `modified_on: string` When the record was last modified. - `proxiable: boolean` Whether the record can be proxied by Cloudflare or not. - `comment_modified_on?: string` When the record comment was last modified. Omitted if there i
[...]
